/*
iplcd (c) Copyright Neil Cherry 2005
Portions of this code have been taken from x10d.c and are (c) Copyright
Daniel D. Lanciani 1995-2005

All rights reserved.
 
iplcd is licensed free of charge for non-commercial distribution and for
personal and internal business use only.  iplcd may not be distributed
for profit, nor may it be included in products or otherwise distributed by
commercial entities to their clients or customers without the prior written
permission of the authors.
 
TO THE EXTENT ALLOWED BY APPLICABLE LAW, iplcd IS PROVIDED
"AS IS", WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE
LIABLE FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO
USE iplcd EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.
 
These copyright, license, and disclaimer notices must be included
with all copies of iplcd.  Modified versions of iplcd must be
marked as such.

ddl@danlan.com
*/


#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <syslog.h>
#include <errno.h>
#include <ctype.h>
#include <string.h>
#include <strings.h>

#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>	// getservbyname()
#include <stdio.h>
#include <stdlib.h>	// malloc()
#include <stdarg.h>

#include "defs.h"
#include "clients.h"

extern int  fdprintf(int fd, const char *format, ...);
extern void parse_user(char *str, int c, int device, fd_set *rset);
extern void badclient(int fd, fd_set *rset);

extern struct sockaddr_in s_in;
extern struct sockaddr_in addr;
extern struct linger linger;

extern Client *clients;

extern int  nclients;
#if 0
extern int  maxclient;
#endif
extern int  n, nclient, on;

// OK, this file is the worst offender in that this contains a lot of Dan's code.

void
new_client(fd_set *rset, int s) {
  socklen_t addrlen;
  int c;
  
  // addrlen should initially contain the size of the structure pointed to by
  // s_in
  addrlen = sizeof(struct sockaddr);	// This is stupid, I have to lie about sockaddr_in !!!

  if((c = accept(s, (struct sockaddr *)&s_in, &addrlen)) >= 0) {
    // set the socket lsocket to NON_BLOCKING
    fcntl(c, F_SETFL, O_NONBLOCK);	/* non-blocking io on control socket */

#ifdef TCPD
    /*
    ** TCPD or TCP Wrappers - man hosts_access
    ** for further details
    */

    if(hosts_ctl(port, STRING_UNKNOWN, inet_ntoa(s_in.sin_addr),
                 STRING_UNKNOWN) == ALLOWED) {
#else
    /*
    ** This is so a user who doesn't have tcp wrappers can compile
    ** the code.
    */

    if(TRUE) {
#endif
#if 0
      // Why do I want to increase the max # of clients I'm adding?
      if(nclient >= maxclient) {
        maxclient += 2;
        if(!(clients = (Client *)realloc((char *)clients, maxclient * sizeof(Client)))) {
          syslog(LOG_CRIT,"out of client memory");
          exit(ENOMEM);
        }
      }
#endif
      setsockopt(c, SOL_SOCKET, SO_LINGER, &linger, sizeof(linger));
      
      clients[nclient].cnt = 0;
      clients[nclient].quiet  = 0;
      clients[nclient].socket = c;
      clients[nclient].ipaddr[257] = (char ) NULL;
      strncpy(clients[nclient].ipaddr, inet_ntoa(s_in.sin_addr), 256); // it's an unsigned 32 bit number

      syslog(LOG_INFO, "New client (IP: %s)", clients[nclient].ipaddr);

      /*
      ** The hello message and no prompt.
      ** I've removed the prompt because it was actually more confusing than
      ** not. This behavior is now more like that of the smtp port daemon.
      */

      fdprintf(clients[nclient++].socket, "%s\r\n", X10D); /* Print the title */

#ifdef LOGIN
      /*
      ** The login/passwd code goes here
      */

      /*
      ** The Read/Write access code goes here.
      */
#endif
      FD_SET(c, rset);
    } else {
      close(c);
    }
  }
  
/*[ End of Security ]**************************************************/
}

/*
** existing_client - service a command request from the clients port.
**
** OK This takes care of the existing client
**
** This function asks read to read in a buffer len (or less if we've read part
** of it so far and have some room left yet). And then we send it to be parsed
*/

// This is Dan's code (with a few of my changes

void
existing_client(fd_set *rset, fd_set *probe, Client *clients, int device) {
  int i, count, l;
  char *p;
  
  //syslog(LOG_INFO, "Existing client");

  for(i = 0; i < nclient; i++) {
    *clients[i].buf = '\n';	// Start with an empty buffer

    if(FD_ISSET(clients[i].socket, probe)) {
      count = sizeof(clients[i].buf) - clients[i].cnt - 1;

      //syslog(LOG_INFO, "client[i] = %d Count = %d (= %d - %d - 1)", i, count , sizeof(clients[i].buf), clients[i].cnt);

      if(count <= 0) {
	syslog(LOG_INFO, "Bad Count = (%d)", count);
        badclient(i, rset);
        i--;
      }

      // Hey We've read in a line of 314 bytes and we read 255+255+0
      // Of course this is bad because this overloads the clients buffer
      // and we try to declare the client as bad. This unfortunately
      // causes us no end of problems (core dump)
      //
      // Aug 30 12:51:48 lha InsteonD[18910]: insteond start
      // Aug 30 12:51:50 lha InsteonD[18911]: New connection
      // Aug 30 12:51:50 lha InsteonD[18911]: Existing client
      //
      // Sent(as one long line):
      //     !w*********1*********2*********3*********4*********5*********6*********7
      //       *********8*********9********10*********1*********2*********3*********4
      //       *********5*********6*********7*********8*********9********20*********1
      //       *********2*********3*********4*********5*********6*********7*********8
      //       *********9********30*********1
      //
      // Aug 30 12:52:04 lha InsteonD[18911]: Existing client
      // Aug 30 12:52:04 lha InsteonD[18911]: client[i] = 0 Count = 255 (= 256 - 0 - 1)
      // Aug 30 12:52:04 lha InsteonD[18911]: Existing client
      // Aug 30 12:52:04 lha InsteonD[18911]: client[i] = 0 Count = 0 (= 256 - 255 - 1)
      // Aug 30 12:52:04 lha InsteonD[18911]: Bad Count = (0)
      // Aug 30 12:52:04 lha InsteonD[18911]: Bad Count [post read] = (-1)
      // poof ( SIGSEGV, Segmentation fault)

      count = read(clients[i].socket, clients[i].buf + clients[i].cnt, count);

      if(count < 0) {
        if(errno != EWOULDBLOCK) {
	  syslog(LOG_INFO, "Bad Count [post read] = (%d)", count);
          badclient(i, rset);
          i--;
        }
        continue;
      }

      if(count == 0) {
	syslog(LOG_INFO, "Bad Count [post read] = (%d)", count);
        badclient(i, rset);
        i--;
        continue;
      }

      clients[i].cnt += count;

      // scan memory for a '\n', shouldn't we look for '\r' ?
      while((p = memchr(clients[i].buf, '\n', clients[i].cnt))) {
        count = p - clients[i].buf + 1;
        //bcopy(clients[i].buf, rbuf, count);
        memcpy(rbuf, clients[i].buf, count); // Parms 1 & 2 are reversed for memcpy

        if(clients[i].cnt -= count) {
          //bcopy(clients[i].buf + count, clients[i].buf, clients[i].cnt);
	  //     dest,           src,                    n
          memcpy(clients[i].buf, clients[i].buf + count, clients[i].cnt);
        }
        
        /*
        ** Looks like a space eater and toupper routine!
        ** Also eats control characters
        **
        ** The only characters I should receive are \r,\n, <SP>
        ** \t, \f (FF), \v (VT) and the normal ASCII characters '!' - '~'
        ** I don't think the extra space characters will hurt the program.
	**
	** This differes a little bit from Dan's code
        */

        for(p = buf, l = count, count = 0; count < l; count++) {
          if(isprint(rbuf[count])) {
            *p++ = rbuf[count]; /* Leaves me with just printable chars and space */
          } else {
            *p = 0;
          }
        }

	//syslog(LOG_INFO, "parse_user(%d) %d", i, count);
        parse_user(buf, i, device, rset);  /* Here is where we parse the clients request */
      } 			/* End of while */
    }                           /* End of if(FD_ISSET(...)) */
  } 				/* End of for loop */
}

/*
** Close wayward client connections
*/

void
badclient(int fd, fd_set *rset)
{
  int c;

  close(clients[fd].socket);                  /* What's the difference between this and shutdown */

  if(rset) {
    // This goes poof if we send too much data and the client disconnects (buffer overflow ?)
    FD_CLR(clients[fd].socket, rset);
  } else {
    // What to do if rset is null ???
    // return ;
  }
  nclient--;

  for(c = fd; c < nclient; c++)
    clients[c] = clients[c + 1];
}
