/*
iplcd (c) Copyright Neil Cherry 2005
Portions of this code have been taken from x10d.c and are (c) Copyright
Daniel D. Lanciani 1995-2005

All rights reserved.
 
iplcd is licensed free of charge for non-commercial distribution and for
personal and internal business use only.  iplcd may not be distributed
for profit, nor may it be included in products or otherwise distributed by
commercial entities to their clients or customers without the prior written
permission of the authors.
 
TO THE EXTENT ALLOWED BY APPLICABLE LAW, iplcd IS PROVIDED
"AS IS", WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE
LIABLE FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO
USE iplcd EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.
 
These copyright, license, and disclaimer notices must be included
with all copies of iplcd.  Modified versions of iplcd must be
marked as such.

ddl@danlan.com
*/


#ifndef DEFS_H
#define DEFS_H

#include <syslog.h> // it was easier to put it here, I'm just lazy

/*
**
** Author:      Neil Cherry
** Date:        10/16/99
** Version:     1.1 (sub alpha)
**
** $Id: hcs_defs.h,v 1.6 1999/11/25 17:32:14 njc alpha njc $
**
** $Log: hcs_defs.h,v $
** Revision 1.6  1999/11/25 17:32:14  njc
** I've added a few defines for the client commands and not much else.  I
** will have to  change hcsd.c so the it uses the  hcs defines instead of
** the hex numbers.
**
** Revision 1.1  1999/10/16 16:37:32  njc
** Initial revision
**
**
*/

/*
** I should really use mallocs instead of this
*/

#ifndef MAXLINE
  #define MAXLINE 256
#endif

/*[ Various global declarations ]****************************************** */

extern void options(int argc, char **argv);

extern char rbuf[MAXLINE];
extern char buf[MAXLINE];	/* possible point for buffer overflows ??? */
extern char xdate[MAXLINE];
extern char port[MAXLINE];
extern char line[MAXLINE];

/*[ tcpd/tcp wrappers stuff ]************************************************/

#ifndef TRUE
  #define TRUE	1
#endif

#ifndef FALSE
  #define FALSE	(!TRUE)
#endif

#define NOT_ALLOWED	(!TRUE)
#define ALLOWED		(TRUE)


/*[ Various definitions ]****************************************************/

#ifndef STDIN
  #define STDIN 0
#endif

#ifndef STDOUT
  #define STDOUT 1
#endif

#ifndef STDERR
  #define STDERR 2
#endif

#ifndef	LOG_LOCAL0
  #define LOG_LOCAL0 0
#endif

/*
** Used by hcsd parse_user.c
*/

#define xDEBUG		'D'
#define xQUIET		'Q'
#define xSTATUS		'S'
#define xHELP		'?'
#define xTIME		'T'
#define xEXIT		'X'
#define xSHUTDOWN	'Z'
#define xCMD		'C'

#define xREAD		'R'	// Read to a memory address
#define xWRITE		'W'	// Write to a memory address
#define xIWRITE		'I'	// Write an Insteon command
#define xXWRITE		'#'	// Write and X10 command
#define xPING		'P'
#define xLICENSE	'L'	// Display license
#define xVERSION	'V'	// Get PLC vesion
#define xUSERS		'U'
#define xTABLE		'T'
#define xADDDEVICE	'A'

#define EOL		"\r\n"
//#define CR		'\r'
//#define NL		'\n'
#define DEL		0x7F

/*
**
*/

#define MASK(s)         (0x000000FF & s)

#define NON_BLOCKING	&on

/*[ Linux definitions ]******************************************************/

#ifndef __linux__               /* I think this should really be gcc not linux */
  #define FD_NULL	(struct fd_set *) 0
  #define TIMEVAL_NULL	(struct timeval *) 0
#else
  #define FD_NULL	(fd_set *) 0
  #define TIMEVAL_NULL	(struct timeval *) 0
#endif

typedef struct client Client;

#define X10D        "iplcd"

#endif
