/*
iplcd (c) Copyright Neil Cherry 2005
Portions of this code have been taken from x10d.c and are (c) Copyright
Daniel D. Lanciani 1995-2005

All rights reserved.
 
iplcd is licensed free of charge for non-commercial distribution and for
personal and internal business use only.  iplcd may not be distributed
for profit, nor may it be included in products or otherwise distributed by
commercial entities to their clients or customers without the prior written
permission of the authors.
 
TO THE EXTENT ALLOWED BY APPLICABLE LAW, iplcd IS PROVIDED
"AS IS", WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE
LIABLE FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO
USE iplcd EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.
 
These copyright, license, and disclaimer notices must be included
with all copies of iplcd.  Modified versions of iplcd must be
marked as such.

ddl@danlan.com
*/


/*
**
** Author:      Neil Cherry
** Date:        10/16/99
** Version:     1.1 (sub alpha)
**
** $Id$
**
** $Log$
**
*/

#include <stdio.h>
#include <sys/types.h>
#include <time.h>

// ===========================================================================

extern int fdprintf(int fd, const char *format, ...);
extern int clprintf(const char *format, ...);

// ===========================================================================

void
help(int user) {
  fdprintf(user, "\r\nHelp message\r\n\n");
  fdprintf(user, "!c<DATA><DATA>... (spaces are permitted between data)\r\n");
  fdprintf(user, "!s - insteond Status\r\n");
  fdprintf(user, "!q - Quiet, send no response back to the user\r\n");
  fdprintf(user, "!x - Exit, disconnect\r\n");
  fdprintf(user, "!z - shutdown daemon\r\n");
  fdprintf(user, "!r - read memory (!r 0x165 0010)\r\n");
  fdprintf(user, "!w - write memory (not working yet)\r\n");
  fdprintf(user, "!i - issue an Insteon command (!i 00.02.C2 on ff)\r\n");
  //  fdprintf(user, "!# - issue an X10 command\r\n");
  fdprintf(user, "!p - ping an Insteon device(1p 00.02.C2)\r\n");
  fdprintf(user, "!v - get version (and MAC address)\r\n");
  fdprintf(user, "!l - display license\r\n");
  fdprintf(user, "!u - list users currently connected\r\n");
  fdprintf(user, "!t - list PLC device table\r\n");
  fdprintf(user, "!a - add device to the PLC device table\r\n");
  fdprintf(user, "?  - this help message\r\n");
  fdprintf(user, "\r\n");
  fdprintf(user, "Example command:\r\n\ta1aon (this sends an on command for A1\r\n");
  fdprintf(user, "\r\n");
}

// =[ TS() ]==================================================================

char *
TS(void) {
  static char ts[100];
  time_t now;
  struct tm *lnow;


  time(&now);
  lnow=localtime(&now);

  sprintf(ts,"%02d/%02d %02d:%02d:%02d",
          lnow->tm_mon+1,lnow->tm_mday,
          lnow->tm_hour, lnow->tm_min,lnow->tm_sec);

  return ts;
}

// =[ dumpinhex() ]===========================================================

void
dumphex(char *str, u_char *buf, int size) {
  int i;

  clprintf("%s %5s: ",TS(), str);

  for(i = 0;i < size;i++) {
    clprintf("%02X ",buf[i]);
  }

  clprintf("\n");
}

// =[ Delay functions ]=======================================================

int
nsDelay(int nsecs) {
  struct timespec req;

  req.tv_sec  = 0;
  req.tv_nsec = nsecs;

  return nanosleep(&req, NULL);
}

int
usDelay(int usecs) {
  struct timespec req;

  req.tv_sec  = 0;
  req.tv_nsec = usecs * 1000;

  return nanosleep(&req, NULL);
}

int
msDelay(int msecs) {
  struct timespec req;

  req.tv_sec  = 0;
  req.tv_nsec = msecs * 1000 * 1000;

  return nanosleep(&req, NULL);
}
