/*
iplcd (c) Copyright Neil Cherry 2005
Portions of this code have been taken from x10d.c and are (c) Copyright
Daniel D. Lanciani 1995-2005

All rights reserved.
 
iplcd is licensed free of charge for non-commercial distribution and for
personal and internal business use only.  iplcd may not be distributed
for profit, nor may it be included in products or otherwise distributed by
commercial entities to their clients or customers without the prior written
permission of the authors.
 
TO THE EXTENT ALLOWED BY APPLICABLE LAW, iplcd IS PROVIDED
"AS IS", WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE
LIABLE FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO
USE iplcd EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.
 
These copyright, license, and disclaimer notices must be included
with all copies of iplcd.  Modified versions of iplcd must be
marked as such.

ddl@danlan.com
*/


#ifndef OPTIONS_H
#define OPTIONS_H
/*
**
** Author:	Neil Cherry
** Date:	10/16/99
** Version:	1.1 (sub alpha)
**
** $Id: options.h,v 1.6 1999/11/25 17:32:14 njc alpha $
**
** $Log: options.h,v $
** Revision 1.6  1999/11/25 17:32:14  njc
** This file contains definitions for use with the options function.
**
** Revision 1.1  1999/10/16 15:46:43  njc
** Initial revision
**
*/

#define HCSDEVICE	'd'
#define EVENTSFILE	'f'
#define LOCK		'l'
#define PORT		'p'
#define SPEED		's'
#define DEBUG		'x'
#define VERSION		'v'
#define NOFORK		'n'
#define myUSB		'u'
#define IP		'i'
#define HELP		'?'

#define EndOfParameters (-1)

#define OFF		0
#define SECOND		1
#define MINUTE		2

/*
** These 2 allow you to select the service and device
**
** Later I'll change this to command line options
*/

#ifndef SERVICE
  #define SERVICE "iplcd"
#endif

#ifndef DEVICE
  #define DEVICE "/dev/iplcd"
#endif

#ifndef HCSFILE
  #define HCSFILE "/usr/local/iplc/events.bin"
#endif

char line[MAXLINE];
char port[MAXLINE];
char lock[MAXLINE];
char hcsfile[MAXLINE];

int file_state = 0;

/*
** Speed: 4800
** Bits:  8,n,1
** Flow:  none
*/

int speed    = 4800;
int debug    = 0;
int interval = MINUTE;
int mydaemon = 1;
int myusb    = 0;

extern char myid[];
//extern char *xdate;

#endif
