/*
** iplcd - daemon interface to the Insteon PLC
** Copyright (C) 2005  Neil Cherry (ncherry@comcast.net)
** http://linuxha.sourceforge.net/
** http://home.comcast.net/~ncherry/index.html
**
** This file is part of iplcd.
**
** iplcd is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** iplcd is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef MYTYPES_H
#define MYTYPES_H

#ifdef __linux__
#include <sys/types.h>
#include <linux/types.h>

typedef __u8  byte;
typedef __u8  u8;
typedef __u16 word;
typedef __u16 u16;
typedef __u32 u32;

#endif

#ifdef OS_FREEBSD
#include <sys/types.h>

typedef u_int8_t  byte;
typedef u_int8_t  u8;
typedef u_int16_t word;
typedef u_int16_t u16;
typedef u_int32_t u32;
#endif

#ifdef OS_AIX
#include <sys/param.h>

typedef u_int8_t  byte;
typedef u_int8_t  u8;
typedef u_int16_t word;
typedef u_int16_t u16;
typedef u_int32_t u32;
#endif

#define HI(x)	(x & 0xff00) >> 8
#define LO(x)	(x & 0x00ff)

#endif // MYTYPES_H
