/*
iplcd (c) Copyright Neil Cherry 2005
Portions of this code have been taken from x10d.c and are (c) Copyright
Daniel D. Lanciani 1995-2005

All rights reserved.
 
iplcd is licensed free of charge for non-commercial distribution and for
personal and internal business use only.  iplcd may not be distributed
for profit, nor may it be included in products or otherwise distributed by
commercial entities to their clients or customers without the prior written
permission of the authors.
 
TO THE EXTENT ALLOWED BY APPLICABLE LAW, iplcd IS PROVIDED
"AS IS", WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE
LIABLE FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO
USE iplcd EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.
 
These copyright, license, and disclaimer notices must be included
with all copies of iplcd.  Modified versions of iplcd must be
marked as such.

ddl@danlan.com
*/


#ifndef UUFUNCS_H
#define UUFUNCS_H
/*
** Author:	Neil Cherry
** Date:	11/25/99
** Version:	1.6 (alpha)
**
**      $Id: uufuncs.h,v 1.6 1999/11/25 17:32:14 njc alpha $
**
**      $Log: uufuncs.h,v $
**      Revision 1.6  1999/11/25 17:32:14  njc
**      This file contains  the definitions need for the  uucp locking code in
**      uucp_locking.c.
**
*/

/*
** function prototypes
*/

#include <errno.h>

#include <sys/wait.h>

#ifndef UUFUNC
extern int	makelock();
extern int	readlock();
extern int	checklock();
#else
int	makelock();
int	readlock();
int	checklock();
#endif

/*
** globals
*/

extern char	*lock;
extern int	errno;

#define TRUE	1
#define FALSE	!TRUE

#define SUCCESS (0)
#define FAIL	(-1)

#define MAXLINE	8192

#ifndef LOCK
  #ifdef __linux__
    #define LOCK	"/var/lock/LCK..%s"
  #else
    #define LOCK	"/usr/spool/uucp/LCK..%s"
  #endif
#endif

#define FOUND	 TRUE	/* Lock file has been found and is a dead process */
#define OURS	 (-2)	/* Lock file has been found and it is our process */
#define DEAD	 (-3)	/* Lock file has been found and is a dead process */
#define DONTKNOW errno	/* Lock file has been found and I don't know what */
#define LIVE	 TRUE	/* Lock file has been found and I don't know what */
#define NOT_FOUND (0)	/* Lock file has not been found                   */

#endif
