/*
iplcd (c) Copyright Neil Cherry 2005
Portions of this code have been taken from x10d.c and are (c) Copyright
Daniel D. Lanciani 1995-2005

All rights reserved.
 
iplcd is licensed free of charge for non-commercial distribution and for
personal and internal business use only.  iplcd may not be distributed
for profit, nor may it be included in products or otherwise distributed by
commercial entities to their clients or customers without the prior written
permission of the authors.
 
TO THE EXTENT ALLOWED BY APPLICABLE LAW, iplcd IS PROVIDED
"AS IS", WITH NO EXPRESS OR IMPLIED WARRANTY, INCLUDING, BUT
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL THE AUTHOR BE
LIABLE FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO
USE iplcd EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY
OF SUCH DAMAGES.
 
These copyright, license, and disclaimer notices must be included
with all copies of iplcd.  Modified versions of iplcd must be
marked as such.

ddl@danlan.com
*/


#ifndef X10_H
#define X10_Hb

#define OK      0x00
#define NACK    0x00

#define xACK    0x55            // Command ACK
#define READY   0x55            // Command ACK

#define PLC     0x5A            // PLC Poll?
#define PLCPOLL 0x5A            // PLC Poll?

#define MACRO   0x5B
#define EEADDR  0x5B

#define RF      0x5D            // RF stuff???
#define RFPOLL  0x5D            // RF stuff???

#define STATUS  0x8B            // Request device status

#define SETCLK  0x9B

#define PFAIL   0xA5

#define XXXX1   0xBB            // Unknown followed by 7 bytes, used at startup ???

#define RI_DIS  0xDB            // Request Status ??? DB xx xx in increments of 32 where xx xx are addresses ie 1FE0 (8160 = 8192 (8K) - 32)

#define RI_EN   0xEB

#define TMDLOAD 0xFB            // Macro/timer? download FB xx xx but 5 bytes follow (???)

#define ADDR    0x04
#define FUNC    0x06

#define HC	0x00
#define HF	0x01

#define HCf(p)	hcode[(0x000000F0 & *p) >> 4]
#define UCf(p)	ucode[(0x0000000F & *p)]

#define AUOff	0x00
#define ALOn	0x01
#define On	0x02
#define Off	0x03
#define Dim	0x04
#define Bright	0x05
#define ALOff	0x06
#define ExCode	0x07
#define HRqst	0x08
#define HACK	0x09
#define Pre1	0x0A
#define Pre2	0x0B
#define ExXfer	0x0C
#define StOn	0x0D
#define StOff	0x0E
#define StRqst	0x0F

#ifndef ETIMEDOUT
#include <errno.h>
#endif

#define TIMEOUT (-ETIMEDOUT)

struct aliases {
  char *name;
  int  len;
  int  code;
};


#endif
